#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec2 _vin_Position;

struct SVertexInput
{
	vec2 Position;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec2 _vout_fragTexCoord;

struct SVertexOutput
{
	vec2 fragTexCoord;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	float Handedness;
} SceneInfo;



void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{

	vOutput.VertexPosition = vec4(vInput.Position, 1.0, 1.0);
	vOutput.fragTexCoord = (vInput.Position + 1.0) / 2.0;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragTexCoord = vec2(0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragTexCoord = vOutput.fragTexCoord;
	gl_Position = vOutput.VertexPosition;
}
